//===================================================================
// This file is provided as part of the ClearImage COM Development Kit
// 
// THIS CODE AND INFORMATION IS PROVIDED "AS IS" WITHOUT  
// WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED,  
// INCLUDING BUT NOT LIMITED TO THE IMPLIED WARRANTIES  
// OF MERCHANTABILITY AND/OR FITNESS FOR A  PARTICULAR PURPOSE. 
// 
// Copyright (C) 2003-2011.  Inlite Research, Inc. All rights reserved 
//===================================================================

#include "stdafx.h"
#include <stdio.h>
CComModule _Module; 

bstr_t ReadDrvLic  (char *fileName);
void PrintDrvLic (_bstr_t txt);

//===============================================================
int main(int argc, char* argv[])
	{
		//  Initailzie COM
	CoInitialize(NULL);
	try 
		{
		char s[256];
		for( ; ; )
			{
			cout << "Enter \"q\" to quit, or file name: ";
			cin.getline (s, sizeof(s));
			if(!stricmp(s, "q"))
					break;
			else if(!stricmp(s, "t"))
				{
				strcpy (s, "ca_dl.jpg");	// use sample driver license image
				}
			else if (strlen(s) == 0)
				continue;
			if ((strlen(s) > 2)  && (*s == '\"') && (*(s + strlen(s) - 1) == '\"'))
				{
				strcpy (s, s+1);
				*(s + strlen(s) - 1) = 0;
				}
			_bstr_t bcdata = ReadDrvLic(s);		
			if (bcdata.length() != 0)
				PrintDrvLic(bcdata);
  		}
		}
	catch (_com_error &ex)
		{
		dump_com_error(ex);
		cout << "Press Enter to continue" << endl;
		cout.flush();
		getchar();
		}
	CoUninitialize();
	return 0;
}

//============================================================
void dump_com_error( _com_error &e ) 
	{ 
	char sMsg[256];
	if (e.Description().length())
		sprintf (sMsg, "=====> COM error: Code: %08lx  Description: %s" , 
						e.Error(), (LPCSTR)e.Description()); 
	else
		sprintf (sMsg, "=====> COM error: Code: %08lx  Message: %s" , 
						e.Error(), (LPCSTR)e.ErrorMessage()); 
		
	cout << sMsg << endl;	
	OutputDebugString(sMsg); 
	}

void PrintDrvLic (_bstr_t txt)
	{
	IDLDecoderPtr decoder;
	HRESULT hr = decoder.CreateInstance(__uuidof(DLDecoder));
	decoder->Decode(txt);
	if ( decoder->xml.length() > 0)
		{
		cout << "last:    " << decoder->last << endl;
		cout << "first:   " << decoder->first << endl;
		cout << "middle:  " << decoder->middle << endl;
		cout << "suffix:  " << decoder->suffix << endl;
		cout << "dob:     " << decoder->dob << endl;
		cout << "eyes:    " << decoder->eyes << endl;
		cout << "hair:    " << decoder->hair << endl;
		cout << "sex:     " << decoder->sex << endl;
		cout << "height:  " << decoder->height << endl;
		cout << "weight:  " << decoder->weight << endl;
		cout << "street:  " << decoder->street << endl;
		cout << "city:    " << decoder->city << endl;
		cout << "state:   " << decoder->state << endl;
		cout << "postal:  " << decoder->postal << endl;
		cout << "country: " << decoder->country << endl;
		cout << "id:      " << decoder->id << endl;
		cout << "issued:  " << decoder->issued << endl;
		cout << "expires: " << decoder->expires << endl;
		cout << endl << "XML Data:" << endl << decoder->xml << endl;
		}
	else
		cout << "NOT a Driver License / ID card" << endl << txt << endl;

	}



//########################################################################
_bstr_t ReadDrvLic(char *fileName)
	{
	try
		{
		ICiServerPtr Ci;
		
		HRESULT hr = Ci.CreateInstance(__uuidof(CiServer));
		ICiPdf417Ptr reader = Ci->CreatePdf417();
		reader->Encodings = (EBarcodeEncoding)102; // Activate DLID reading mode
		reader->Image->Open(_bstr_t(fileName), 1);
		ICiBarcodePtr bc = reader->FirstBarcode();
		if (bc != nullptr)
			{return bc->Text;}
		return "";
		}
	catch (_com_error &ex)
		{
		dump_com_error(ex);
		return "";
		}
	}